# SPDX-FileCopyrightText: The maven-build-process Authors
# SPDX-License-Identifier: 0BSD

name: Update Dependencies
on:
  schedule:
    - cron:  0 0 * * THU
jobs:
  update:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v3
      - uses: ./.github/actions/managed-java
      - uses: actions/cache@v3
        with:
          path: ~/.m2/repository
          key: ${{ runner.os }}-maven-${{ hashFiles('**/pom.xml') }}
          restore-keys: |
            ${{ runner.os }}-maven-
      - id: update
        name: Update properties
        run: mvn --batch-mode --update-snapshots --define generateBackupPoms=false versions:update-properties
      - id: cpr
        name: Create Pull Request
        uses: peter-evans/create-pull-request@v4
        with:
          token: ${{ secrets.PAT }}
          commit-message: Update properties to their latest versions
          committer: GitHub <noreply@github.com>
          author: ${{ github.actor }} <${{ github.actor }}@users.noreply.github.com>
          title: Update properties to their latest versions
          body: |
            `mvn --batch-mode --update-snapshots --define generateBackupPoms=false versions:update-properties`
          labels: |
            enhancement
          assignees: |
            sebhoss
          draft: false
          base: main
          branch: update-properties
          delete-branch: true
      - name: Enable Pull Request Automerge
        if: steps.cpr.outputs.pull-request-operation == 'created'
        uses: peter-evans/enable-pull-request-automerge@v2
        with:
          token: ${{ secrets.PAT }}
          pull-request-number: ${{ steps.cpr.outputs.pull-request-number }}
          merge-method: rebase
